library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity walkthru1_top is
    Port ( clk : in std_logic;
           reset : in std_logic;
		   en1 : in std_logic;
		   en2 : in std_logic;
		   en3 : in std_logic;
           o1 : out std_logic;
           o2 : out std_logic);
end walkthru1_top;

architecture Behavioral of walkthru1_top is

signal q: std_logic_vector(29 downto 0);
signal en: std_logic;
signal n1, n2, n3 : std_logic;

begin

en <= en1 and en2 and en3;
process(reset, clk)
begin
	if(reset = '1') then
		q <= (others => '0');
	elsif(clk'event and clk = '1') then
		if(en = '1') then
			q <= q + 1;
		end if;
	end if;
end process;

n1 <= '1' when q = 100 else '0';
n2 <= '1' when q = 1000 else '0';
n3 <= '1' when q = 1000 else '0';

o1 <= (n1 or n2) and en;
o2 <= (n2 or n3) and en;

end Behavioral;